
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	BitABitToolbox.c

	Quelques fonctions bien utiles. 

\*================================================*/


#include "BitABitToolbox.h"


/*----------- LES FONCTIONS DE BASE---------------*/
/*----------- POUR LE TYPE CHAR ------------------*/

/*------------------------------------------------*\
  Rend le n-ieme bit du nombre "nombre". 
  On commence avec le bit 0 pour les unites et on 
  finit avec le bit 7 pour 128, etc. 
\*------------------------------------------------*/

static int _NiemeBitChar(char nombre, int n)
{
  if((n<0)||(n>=8))
    {printf("NiemeBitChar : n doit etre entre 0 et 7 et non %d\n", n); 
    return(-1);}
  else
    return((nombre & (1<<n))>>n); 
}


/*------------------------------------------------*\
  Change le n-ieme bit pour le mettre a value
  (On commence avec le bit 1 pour les unites et 
  le bit 8 pour 128 etc. 
\*------------------------------------------------*/

static void _SetNiemeBitChar(char *nombre, int n, int value)
{
  if(value)
    *nombre = *nombre | (1<<n) ;
  else
    *nombre = *nombre & (~(1<<n)) ;
}


/*------------------------------------------------*\
  Change la valeur du n-ieme bit de car 0<->1.
\*------------------------------------------------*/

static void _ChangeNiemeBitChar(char *nombre, int n)
{
  *nombre = (*nombre)^(1<<n);
}


/*-------- LES FONCTIONS A UTILISER -------------*/
/*--------POUR TOUS LES AUTRES TYPES ------------*/


/*------------------------------------------------*\
  taille est la taille de l'objet en octets. 
  On commence avec le bit 0 pour les unites. 
  Le bit 7 correspond au terme en x7; 
  Donc dans 19=10011 les bits 0, 1 et 4 sont a 1
  et les autres sont a 0. 
\*------------------------------------------------*/

char BAB_NiemeBit(void *objet, int taille, int n)
{
  char *obj_loc; 

  if((n<0)||(n>=taille*8))
    {
      printf("Cet objet a %d octets donc n'a pas de bit numero %d.\n", 
	     taille, n);
      return(-1);
    }
  else
    {
      obj_loc=objet; 
      return(_NiemeBitChar(obj_loc[taille-1-n/8], n%8));
    }
}


/*------------------------------------------------*\
  taille est la taille de l'objet en octets. 
  On commence avec le bit 0 pour les unites. 
  Le bit 7 correspond au terme en x7; 
  Donc dans 19=10011 les bits 0, 1 et 4 sont a 1
  et les autres sont a 0. 
  Cette fonction met le bit n a la valeur value. 
\*------------------------------------------------*/

void BAB_SetNiemeBit(void *objet, int taille, int n, int value)
{
  char *obj_loc; 

  if((n<0)||(n>=taille*8))
    {
      printf("Cet objet a %d octets donc n'a pas de bit numero %d.\n", 
	     taille, n);
    }
  else
    {
      obj_loc=objet; 
      _SetNiemeBitChar(&(obj_loc[taille-1-n/8]), n%8, value);
    }
}


/*------------------------------------------------*\
  taille est la taille de l'objet en octets. 
  On commence avec le bit 0 pour les unites. 
  Le bit 7 correspond au terme en x7; 
  Donc dans 19=10011 les bits 0, 1 et 4 sont a 1
  et les autres sont a 0. 
  Cette fonction change la valeur du bit 
  numero n : 1<->0.
\*------------------------------------------------*/

void BAB_ChangeNiemeBit(void *objet, int taille, int n)
{
  char *obj_loc; 

  if((n<0)||(n>=taille*8))
    {
      printf("Cet objet a %d octets donc n'a pas de bit numero %d.\n", 
	     taille, n);
    }
  else
    {
      obj_loc=objet; 
      _ChangeNiemeBitChar(&(obj_loc[taille-1-n/8]), n%8);
    }
}


/*------------------------------------------------*\
  Montre tous les bits d'un objet en mettant les 
  bits de poids faible a droite. 
\*------------------------------------------------*/
 
void BAB_Check(void *objet, int taille, char *commentaire)
{
  int i; 

  printf("%s :", commentaire);  

  for(i=taille*8-1; i>=0; i--)
    {
      printf("%d", BAB_NiemeBit(objet, taille, i));
      if(i%8==0) printf(" ");
    }
  printf("\n");
}



