
/*===============================================*\
  
  Mercredi 13 Decembre 2000  

  Arash HABIBI
  
  main.c
  
  Le module principal. 
  
\*================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SocketToolbox.h"

#define E_TAILLE_TRAME (256)

/*------------------------------------------------*\
\*------------------------------------------------*/

void _TraitementParametres(int argc, char **argv, short *port_local, char *nomfich)
{
  if(argc<3)
    {
      fprintf(stderr,"\nUsage : %s port_local nom_fich_a_emettre\n\n", argv[0]);
      exit(1);
    }
  else
    {
      *port_local = atoi(argv[1]);
      strcpy(nomfich, argv[2]); 
    }
}


/*------------------------------------------------*\
\*------------------------------------------------*/

int main(int argc, char **argv)
{
  int nb_recu, nb_lu, nb_emis, socket_fd, taille_adresse; 
  char trame[E_TAILLE_TRAME], nom_fich_a_emettre[50]; 
  short port_local;
  struct sockaddr_in adr_locale, adr_medium;
  FILE *fich_a_emettre; 

  _TraitementParametres(argc, argv, &port_local, nom_fich_a_emettre); 

  socket_fd = ST_GetAndBindSocket(SOCK_DGRAM, port_local, &adr_locale);
  printf("\n%s connect sur le port numro %d\n", argv[0], adr_locale.sin_port); 
  
  taille_adresse = sizeof(struct sockaddr_in);
  nb_recu = recvfrom(socket_fd, trame, E_TAILLE_TRAME, 0, 
		     (struct sockaddr *) &adr_medium,
		     &taille_adresse); 
  
  if(nb_recu<0) {perror("%s recvfrom"); return(-1);}
  
  printf("Connexion russie avec medium.\n"); 
  printf("Frapper \'q\' pour quitter\n\n"); 

  fich_a_emettre = fopen(nom_fich_a_emettre, "r"); 
  if(fich_a_emettre==NULL)
    {perror(nom_fich_a_emettre); exit(1);}

  do
    {
      nb_lu = fread(trame, 1, E_TAILLE_TRAME, fich_a_emettre); 
      if(nb_lu<0)
	{perror("fread"); exit(1); }

      nb_emis = sendto(socket_fd, trame, nb_lu, 
		   0, (struct sockaddr*) &adr_medium, 
		   sizeof(adr_medium));
    }
  while(nb_lu>0);

  printf("Le fichier %s a t intgralement transmis.\n\n", nom_fich_a_emettre); 

  return 0;
}
