
/*===============================================*\
  
  Mercredi 13 Decembre 2000  

  Arash HABIBI
  
  Medium.c
  
  Le module qui s'occupe des echanges. 
  
\*================================================*/


#ifndef _MEDIUM__H
#define _MEDIUM_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <sys/time.h>
#include <errno.h>
#include <fcntl.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "SocketToolbox.h"

// Le nombre de secondes qu'on attend avant d'envoyer MediumOnLine
#define M_TIMEOUT (1.0)

// La taille des buffers de lecture de l'cran 
#define M_TAILLE_TRAME (256)

// Les diagnostiques envoys par les fonctions de ce module sont : 
// Les noms sont assez explicites je crois. 
#define M_ERREUR (-1)
#define M_TOUT_BAIGNE (0)
#define M_TERMINE (1)

// Cette fonction prend en argument le descripteur de la socket locale (socket_fd) et les adresses (adr_1 et adr_2)  
// de deux stations qui se sont dj connects sur des ports UDP et qui attendent que le medium leur envoie une trame 
// de type MediumOnLine pour manifester sa prsence. taux_perte et taux_erreur sont des flottants compris entre 0 et 1
// et qui permet  la fonction appelante de rgler la probabilit de perte pour une trame qui traverse ce medium ou 
// la probabilit pour qu'une trame comporte une erreur de 16 bits. 

extern int M_ExecMedium(struct sockaddr_in adr_1, struct sockaddr_in adr_2, float taux_perte, float taux_erreur);

#endif
