
/*===============================================*\
  
  Mercredi 13 Decembre 2000  

  Arash HABIBI
  
  main.c
  
\*================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SocketToolbox.h"

#define R_TAILLE_TRAME (256)

/*------------------------------------------------*\
\*------------------------------------------------*/

void _TraitementParametres(int argc, char **argv, short *port_local, char *nomfich)
{
  if(argc<3)
    {
      fprintf(stderr,"\nUsage : %s port_local fich_a_emettre\n\n", argv[0]);
      exit(1);
    }
  else
    {
      *port_local = atoi(argv[1]);
      strcpy(nomfich, argv[2]); 
    }
}


/*------------------------------------------------*\
\*------------------------------------------------*/

int main(int argc, char **argv)
{
  int nb_recu, nb_ecrit, socket_fd, taille_adresse; 
  char trame[R_TAILLE_TRAME], nom_fich_a_enregistrer[50]; 
  short port_local;
  struct sockaddr_in adr_locale, adr_medium;
  FILE *fich_a_enregistrer; 

  _TraitementParametres(argc, argv, &port_local, nom_fich_a_enregistrer); 

  socket_fd = ST_GetAndBindSocket(SOCK_DGRAM, port_local, &adr_locale);
  printf("\n%s connect sur le port numro %d\n", argv[0], adr_locale.sin_port); 

  taille_adresse = sizeof(struct sockaddr_in);
  nb_recu = recvfrom(socket_fd, trame, R_TAILLE_TRAME, 0, 
		    (struct sockaddr *) &adr_medium,
		    &taille_adresse); 

  if(nb_recu<0) {perror("recvfrom"); return(-1);}

  printf("Connexion russie avec medium.\n"); 
  printf("Frapper \'q\' pour quitter\n\n"); 

  fich_a_enregistrer = fopen(nom_fich_a_enregistrer, "w"); 
  if(fich_a_enregistrer==NULL)
    {perror(nom_fich_a_enregistrer); exit(1);}

  do
    {
      nb_recu = recvfrom(socket_fd, trame, R_TAILLE_TRAME, 
			  0, (struct sockaddr*) &adr_medium, 
			  &taille_adresse);

      nb_ecrit = fwrite(trame, 1, nb_recu, fich_a_enregistrer); 
      if(nb_ecrit<0)
	{perror("fwrite"); exit(1); }
    }
  while((nb_recu == R_TAILLE_TRAME)||(nb_recu == 15)); 

  printf("Le fichier reu a t intgralement enregistr sous %s.\n\n", nom_fich_a_enregistrer); 

  return 0;
}
